#include "defextern.h"

#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <fstream.h>
#include <windows.h>
#include <commdlg.h>
#include "resource.h"
#include "file.h"
#include "urlmake.h"

char buff[16000];

void getname(char *buffer, char *name)
{
	strcpy(name,"");
	char *p=strchr(buffer,',');
	if(p==NULL) return;
	p[0]=0;
	p++;
	if(p[0]==0) 
	{
		p=buffer;
	}
	strcpy(name,p);
}

BOOL isUrl(char *url)
{
	return (strncmp(url,"http://",7)==0);
}

void geturl(char *buffer, char *url)
{
	strcpy(url,"");
	char *top=buffer;
	if(!isUrl(top)) return;
	char *p=strchr(buffer,',');
	if(p==NULL) return;
	p[0]=0;
	/*
	p++;
	if(p[0]==0) 
	{
		p=buffer;
	}*/
	strcpy(url,top);
}

// ^uR}Ő؂蕪
//
// Ȃ܂,http://www/w/

void geturl(char *buffer, char *url,char *name)
{
	char *p1;
	char *p2;
	char *p;
	char sep;

	strcpy(url,"");
	strcpy(name,"");
	if(strlen(buffer)==0) return;
	p1=buffer;

	sep=',';
	p=strrchr(buffer,sep);
	if(p==NULL) 
	{
		sep='\t';
		p=strrchr(buffer,sep);
		if(p==NULL) return;
	}
	p[0]=0;
	p++;
	if(p[0]==0) 
	{
		p=buffer;
	}
	p2=p;
	if(isUrl(p1)) 
	{
		strcpy(url,p1);
		strcpy(name,p2);
	}
	if(!isUrl(p1) && isUrl(p2)) 
	{
		strcpy(name,p1);
		strcpy(url,p2);
	}
}

void safefilename(char *name)
{
	for (int i=0;i<strlen(name);i++) if(strchr("\\:;,<>/*?|\"",name[i])!=NULL) name[i]='~';
}


BOOL writeshortcut(char *name,char *url)
{
	static int num=0;
	BOOL ans=FALSE;
	ofstream ou;
	char name0[MAX_PATH];
	char *p;
	strcat(name,".url");
	p=name;
	while(p[0]==' ') p++;
	BOOL flag=exist(p);
	ou.open(p);
	if(!ou)
	{
		ou.clear();
		/*
		while(1)
		{
			num++;
			wsprintf(name0,"%d.url",num);
			if(!exist(name0) || num>1000) break;
		}
		*/
		strcpy(name0,name);
		safefilename(name0);
		ou.open(name0);
	}
	if(ou) 
	{
		ans=TRUE;
		/*
		ou<<"[DEFAULT]"<<endl;
		ou<<"BASEURL=";
		ou<<url;
		ou<<endl<<endl;
		*/

		ou<<"[InternetShortcut]"<<endl;
		ou<<"URL=";
		ou<<url;
		ou<<endl;
		ou.close();
	}
	else ou.clear();
	return ans;
}

// 啶ŕr

int strcmpAa(char *str, char *str1)
{
	if(strlen(str)!=strlen(str1)) return -1;
	for(int i=0;i<strlen(str);i++) if(tolower(str[i])!=tolower(str1[i])) return -1;
	return 0;
}
// 啶ŕr

int strncmpAa(char *str, char *str1,int n)
{
	for(int i=0;i<n;i++) if(tolower(str[i])!=tolower(str1[i])) return -1;
	return 0;
}


// html t@C@V[gJbg쐬A
//
// ^Cg𖼑Oɂ
// F^Cgꍇ͌̂̂ŏ㏑Ă܂ (㏑mFȂ)
int urlmakeHtml(char *file)
{
	char buffer[10000]="";
	char buffernext[10000]="";
	char name[10000];
	char url[10000];
	ifstream in(file,ios::nocreate);
	ofstream ou;
	ofstream lo("log.txt");
	int count=0;
	char *pstart=NULL;
	char *pend;
	char *namestart;
	char *nameend;
	do
	{
		if(pstart==NULL)
		{
			while(!in.eof())
			{
				in.getline(buff,1000);
				if (in.gcount()!=0) break;
			}
		}
		pstart=buff;
		pstart=strstr(pstart,"http://");
		if(pstart==NULL) continue;
		wsprintf(buffer,"%s",pstart);
		pend=strchr(buffer,'>');
		namestart=NULL;
		if(pend!=NULL) 
		{
			if(strlen(pend)>1) namestart=pend+1;
			pend[0]=0;
		}
		pend=strchr(buffer,'\"');
		if(pend!=NULL) pend[0]=0;
		pend=strchr(buffer,' ');
		if(pend!=NULL) pend[0]=0;
		wsprintf(url,"%s",buffer);

		if(namestart!=NULL) 
		{
			wsprintf(name,"%s",namestart);
		}
		else
		{
			while(!in.eof())
			{
				in.getline(buff,1000);
				if(in.gcount()!=0) break;
			}
			wsprintf(name,"%s",buff);
		}
		nameend=strchr(name,'<');
		pstart=NULL;
		if(nameend!=NULL) 
		{
			if(strlen(nameend)>1) pstart=nameend+1;
			nameend[0]=0;
		}
		lo<<name<<endl;
		wsprintf(buff,"%s",pstart);
		if(writeshortcut(name,url)) count++;
		
	} while (!in.eof() || pstart!=NULL);
	return count;
}


int urlmake(char *file)
{
	if( checkExt(file,"htm") || checkExt(file,"html") ) return urlmakeHtml(file);
	char name[1000];
	char url[1000];
	ifstream in(file,ios::nocreate);
	int count=0;
	//ofstream log("URL.txt");
	if(in) do
	{
		in.getline(buff,1000);
		if(in.gcount()==0) continue;
		geturl(buff,url,name);
		if(strlen(url)>0 && strlen(name)>0) 
		{
			if(writeshortcut(name,url)) count++;
		}
		//log<<url<<endl;
	} while(!in.eof());
	return count;
}
